/* Laura July 2014
//Functions to control the BlinkMMax
//NOTE: just the master should use these!  We don't want the slaves to talk to their blinks; that nests too many wire transmissions
*/

/*
 * BlinkM connections to Arduino
 * PWR - -- gnd -- black -- Gnd
 * PWR + -- +5V -- red   -- 5V
 * I2C d -- SDA -- green -- Analog In 4
 * I2C c -- SCK -- blue  -- Analog In 5
//FOR ARDUINO 1.0
KEY FUNCTIONS
        BlinkM_fadeToRGB( blinkm_addr, a,b,c);
        BlinkM_setRGB( blinkm_addr, a,b,c);

*/


//---------------------------------------------------------------------------


//Function to get the blink ready to go and talk to
void blinkStart(){
  if( BLINKM_ARDUINO_POWERED )
    BlinkM_beginWithPower();
  else
    BlinkM_begin();
  delay(200); // wait a bit for things to stabilize: inlude this
  BlinkM_off(0);  // turn everyone off
}

//---------------------------------------------------------------------------

//function to send the button values to the BlinkMMax
void blinkMMaxSend(boolean a, boolean b, boolean c){
  //not sure if we should have this line or not
  blinkStart();
  BlinkM_setRGB( blinkAddr, a*254,b*254,c*254); 
}


