
/*
LP 6/26/14
Arduino control of motors using duty cycle for hamper height changing
Try to control it like it will be controled--trying to make this more realistic now
built off my motorsLP4

WANT:
forward direction at manageable (consistent) speed
backward direction at manageable (consistent speed
ideally both speeds are the same
=>function where you can input time and direction and get the motor to turn that way

=>reads duration and direction data from serial--try keyboard input?
=>ideaaly we network this next

//NOTE: I think millis() clock is ~twice as slow....due to slowing things down for motors?
//NOTE: want button to be "off" during the moving phases, but accessible during the stop phases.


 tutorial: 
 http://arduino.cc/en/Tutorial/SecretsOfArduinoPWM
 
 we're using arduino uno; has atmel atmega 328P-PU
 duemilanove uses 328...datasheet seems to indicate this is basically the same, hopefully good to go
 
 From using the oscilloscope and the signal generator with vasant we know:
 ~9.4% is the control value--motor is not moving
 7.5% is fast backward
 12.5% is fast forward
 
 signal is at 60 Hz 
 signal ranges from 0 to 3.3 V
 
 
 So how to do this: from tutorial
 The following code fragment sets up fast PWM on pins 3 and 11 (Timer 2),  using OCR2A as the top value for the timer. The waveform generation mode 
 bits WGM are set to to 111 for fast PWM with OCRA controlling the top limit. 
 The OCR2A top limit is arbitrarily set to 180, and the OCR2B compare register 
 is arbitrarily set to 50. OCR2A's mode is set to "Toggle on Compare Match" by setting the COM2A bits to 01.
 
 
 
 pinMode(3, OUTPUT);
 pinMode(11, OUTPUT);
 TCCR2A = _BV(COM2A0) | _BV(COM2B1) | _BV(WGM21) | _BV(WGM20);
 TCCR2B = _BV(WGM22) | _BV(CS22);
 OCR2A = 180;
 OCR2B = 50;
 
 On the Arduino Duemilanove, these values yield:
 Output A frequency: 16 MHz / 64 / (180+1) / 2 = 690.6Hz
 [[16 HMz / 64 bits / (OCR2A value + 1)/ (2 b/c COM2A = 01)
 Output A duty cycle: 50%
 OCR2B
 
 Output B frequency: 16 MHz / 64 / (180+1) = 1381.2Hz
 [[16 Mhz / 64 bit / (OCR2A + 1)
 Output B duty cycle: (50+1) / (180+1) = 28.2%
 [[(OCR2B + 1)/(OCR2A + 1)]]
 
 Note that in this example, the timer goes from 0 to 180, which takes 181 
 clock cycles, so the output frequency is divided by 181. Output A has half 
 the frequency of Output B because the Toggle on Compare Match mode toggles 
 Output A once each complete timer cycle.
 
 ---
 Try to implement
 10%
 signal is at 60 Hz 
 signal ranges from 0 to 3.3 V
 
 OCR2B = 10
 want 16,000,000/ 64 / (OCR2A + 1) / 2 = 60 Hz
 OCR2A = 2,082
 ==highest OCR2A value is definitely less than this. 
 ==need to try another approach as below.
 
 
 
 ----
 here's one for slower Hz
 http://www.fiz-ix.com/2012/01/how-to-configure-arduino-timer-2-registers-to-drive-an-ultrasonic-transducer-with-a-square-wave/
 
 leads us to:
 
 TCCR2A = _BV(COM2AO)|_BV(WGM21)|_BV(WGM20);
 //Setting the COM2Ax bits to 01 sets timer/counter2 to toggle OCR2A 
 //(i.e., Arduino digital pin 11) from high to low when the counter matches OCR2A
 TCCR2B = _BV(WGM22)|_BV(CS22)|_BV(CS21)|_BV(CS20);
 //set CS22 CS21 CS20 to 111 to make counter update every 1024 clock cycles
 //the WGM registers (22, 21, 20) to 111 set mode to fast PWM with OCRA controlling the top limit
 OCR2A = B10000010; //(decimal value 130 set for frequency needs)
 OCR2B = 20;
 //OCR2B gives one of the duty cycles
 //other duty cycle is (OCR2B + 1)/(OCR2A+1)=21/131 = 16%
  

 ATTACHING THINGS;
**see schematic motorControllerSetup4.1.14.pdf 
 
 
 */
 
//Want function to make the motor run with a certain duty cycle
//It needs to see a range of values to move.  (b/c callibration to controller)
//Use this in setup to get the "baseline" established
 
 
/////////////////////////////////////////////////////////////////////////////////////////////////////////


//Function for all the motor setup
void motorSetup(int motorPin){
//set up the motor pins
  pinMode(motorPin, OUTPUT);

//Set the clock speed slower so we can get the right duty cycles
//UNCLEAR IF THIS IS WORKING CLOCK SEEMS WEIRD
//but motor beeps angrily if we leave this out
  TCCR2A = _BV(COM2A0)|_BV(COM2B1) |_BV(WGM21)|_BV(WGM20);
  TCCR2B = _BV(WGM22)|_BV(CS22)|_BV(CS21)|_BV(CS20);
  
  
  //Put things in neutral to get initial setting
  startMotor();
//  motorSetTwo(5000, OCR2Bstop);
  motorBBCsetup(5000, OCR2Bstop);
}  


//Function to start the motor
void startMotor()
{
/*
  //get the motor going   
//  TCCR2A = _BV(COM2A0)|_BV(WGM21)|_BV(WGM20);
  TCCR2A = _BV(COM2A0)|_BV(COM2B1) |_BV(WGM21)|_BV(WGM20);
  //Setting the COM2Ax bits to 01 sets timer/counter2 to toggle OC2A 
  //(i.e., Arduino digital pin 11) from high to low when the counter matches OCR2A
  TCCR2B = _BV(WGM22)|_BV(CS22)|_BV(CS21)|_BV(CS20);
  //set CS22 CS21 CS20 to 111 to make counter update every 1024 clock cycles
  //the other one just because?
  //SWITCHED THESE TO GET BETTER VALUES
  //  OCR2A = B10000010; //(decimal value 130 set for frequency needs)  
//  OCR2B = B00010100; //decimal value 20;

*/
  OCR2A = OCR2Avalue;  
//I want to be able to increment this value
  OCR2B = OCR2Bvalue;

  //OCR2B gives one of the duty cycles
  //other duty cycle is (OCR2B + 1)/(OCR2A+1)=27/254 = 10.5%
  //other duty cycle is (OCR2B + 1)/(OCR2A+1)=21/131 = 16%
 
}


//Function to turn the direction into a value that we can use to turn the motors (i.e. OCR2B value)
int motorDirectionToValue(boolean motorDirection){
   //figure out how direction received from serial translates to values that can be motor inputs
  if (motorDirection == 1){
    OCR2Bvalue = OCR2Bbackwards; //backwards
  }
  else {
    OCR2Bvalue = OCR2Bforwards; //forwards
  }
 return(OCR2Bvalue);
}
/////////////////////////////////////////
//For debugging purposes--see where we are getting stuck
//Function to turn the motor based on data in from serial
//Use with motorDirectionToValue
void motorBBCsetup(int runTime, int OCR2Bvalue){
  motorStartMillis = millis();
  nowTime = millis();
  
  while (nowTime < (motorStartMillis + runTime)) {
  
  OCR2A = OCR2Avalue;  
  OCR2B = OCR2Bvalue;
  nowTime = millis();
  
  }  

}
/////////////////////////////////////////////////////////

//Function to turn the motor based on data in from serial
//Use with motorDirectionToValue
//make sure python is writing to the correct arduino or nothing will happen
//delays let us control how long the motor goes--sigh.
void motorBBC(int runTime, int OCR2Bvalue){

  //these end up being identical--so just measure once.
  motorStartMillis = millis();
  nowTime = motorStartMillis;
    
     //RUN STUFF.  It doesn't like adding or measuring time... but this seems okay
  while (nowTime < (motorStartMillis+runTime)) {
 
  //right now they run even with the delays included
  OCR2A = OCR2Avalue;  
  OCR2B = OCR2Bvalue;
  //delay 10,000 and increment 1 seems to be ballpark to get it to move. Tweak as needed.
  delay(50000);  
  nowTime = nowTime+1;
  
  }  
}


/////////////////////////////// OLD
/*
//Function to turn the motor based on data in from serial
//Use with motorDirectionToValue
void motorBBC(int runTime, int OCR2Bvalue){

  TCCR2A = _BV(COM2A0)|_BV(COM2B1) |_BV(WGM21)|_BV(WGM20);
  TCCR2B = _BV(WGM22)|_BV(CS22)|_BV(CS21)|_BV(CS20);

  motorStartMillis = millis();
  //Serial.print("motorStartTime:");
  //Serial.println(motorStartMillis);
  nowTime = millis();
  //Serial.print("nowTime:");
  //Serial.println(nowTime);
  
  
  //while (nowTime < (motorStartMillis + runTime)) {
  
    int i = 0;
    
     //RUN STUFF
     //THIS VERSION WORKS--FIGURE OUT WHY!!!
  while (nowTime < (motorStartMillis+150)) {
  //  while (i < 10000) {
        
  //Get things moving  
  TCCR2A = _BV(COM2A0)|_BV(COM2B1) |_BV(WGM21)|_BV(WGM20);
  TCCR2B = _BV(WGM22)|_BV(CS22)|_BV(CS21)|_BV(CS20);
  
  //right now these values aren't running anything when we're just doing the count
  //but they run even with the delays including (maybe not hitting the delay?)
  OCR2A = OCR2Avalue;  
  OCR2B = OCR2Bvalue;
  
  
  //lights version
    digitalWrite(8, HIGH);
    delay(10000);
    digitalWrite(8, LOW);
    delay(10000);
  
  nowTime = nowTime+10;
  i=i+1;
  delay(500);
  //Serial.println(nowTime);
  
  }  
  
  
  
  
  //LIGHT STUFF
  unsigned long i = 1;
   motorEndMillis = motorStartMillis +1;
   //sometimes printing to serial is too strenuous, other times it works
   //Serial.print("motorEndMillis: ");
   delay(500);
   //Serial.println(motorEndMillis);
   //adding nothing is fine...adding one puts us over the edge into forever blinking!
   //but if you serial print the value it looks fine
  delay(500);
  while (i<nowTime){
    delay(500);
   //Serial.print("a");  //It will print this a few times at least...but not i value itself.  Time loops around too fast?!
   i=i+10000;
  }


 i=1;
     while (i<motorEndMillis){
     digitalWrite(8, HIGH);
    delay(10000);
    digitalWrite(8, LOW);
    delay(10000);
    i= i+10000;
    Serial.println("first loop");
    }

    while (nowTime<motorEndMillis){
     digitalWrite(12, HIGH);
    delay(10000);
    digitalWrite(12, LOW);
    delay(10000);
    i=i+10000;
    delay(500);
   // nowTime = millis();
    //Serial.print("second loop: ");
    delay(500);
   // Serial.println(nowTime);
    }
 
   
   
  while(nowTime<(motorStartMillis+5000)){
    for (int i=1; i<motorStartMillis; i+10000){
     digitalWrite(12, HIGH);
    delay(10000);
    digitalWrite(12, LOW);
    delay(10000);
    }
    nowTime = millis();
//   x=x+10000;    //current time reading as ~60,000
  }
  
  
    // digitalWrite(12, HIGH);
   // delay(10000);
   // digitalWrite(12, LOW);
   // delay(10000);
  //Serial.println(nowTime);
  //Serial.println("END");
}
*/

//////////////////////////////////////////////////////////////////////
//Function to set the motor at a certain speed for a certain time
//This can include setting it to stop at the neutral position
void motorSet(unsigned long runTimeEnd, unsigned long previousRunTimeEnd, int OCR2Bset)
{
  //runTime is how long it goes in milliseconds, OCR2Bset controls the speed--see function
  //eventually return the counter value associated with the speed?
  currentMillis = millis();
  if((currentMillis % totalTime) < runTimeEnd && (currentMillis % totalTime) >= previousRunTimeEnd){
  //get the motor going and wait for a little bit
  
  TCCR2A = _BV(COM2A0)|_BV(COM2B1) |_BV(WGM21)|_BV(WGM20);
  TCCR2B = _BV(WGM22)|_BV(CS22)|_BV(CS21)|_BV(CS20);
  OCR2A = OCR2Avalue;  
  OCR2B = OCR2Bset;

  }
}

//Function to set the motors based on overall total running time and a value for OCR2B
void motorSetTwo(unsigned long runTime, int OCR2Bset)
{
  motorStartMillis = millis();
  unsigned long nowTime = millis();
  while (nowTime < (motorStartMillis + runTime)) {

  TCCR2A = _BV(COM2A0)|_BV(COM2B1) |_BV(WGM21)|_BV(WGM20);
  TCCR2B = _BV(WGM22)|_BV(CS22)|_BV(CS21)|_BV(CS20);
  OCR2A = OCR2Avalue;  
  OCR2B = OCR2Bset;
  nowTime = millis();
  }
}


//Function to put the motor in its resting state (stopped) and listening to the button for input
void motorRest()
{  
  //MAYBE WE COMMENT OUT THESE FIRST TWO LINES
  TCCR2A = _BV(COM2A0)|_BV(COM2B1) |_BV(WGM21)|_BV(WGM20);
  TCCR2B = _BV(WGM22)|_BV(CS22)|_BV(CS21)|_BV(CS20);
  OCR2A = OCR2Avalue;  
  OCR2B = OCR2Bstop;

}

/*
//OLD function to read the button and change duty cycle value accordingly
void readButton(int buttonPinNum){
 int buttonSituation = digitalRead(buttonPin[buttonPinNum]);
 if (buttonSituation ==1)
  //we're using pin 3: duty cycle = (OCR2B + 1)/(OCR2A+1) = (x+1)/254 
  //I don't want the full range of the duty cycle
  //set range to ~7 to 12 % (means OCR2B values of 16 to 30)
  //if you go out of range, motor stops and gets messed up until it hits zero value again?
  //mod adjusts the range of the percents, intercept adjusts the minimum value

  //plus 1 for incrementing the counter when button is pressed
  OCR2Bcounter = OCR2Bcounter + 1;
  //Turn this into a duty cycle value that I want
  //I think mod should be 18 and the intercept should be 16 but apparently not??
  OCR2Bvalue = (OCR2Bcounter % 12) + 22;
  //5% duty cycle is too low
  //14 and 20 are pretty good values to get this
 // 
    
}
*/

//Function to make the motor move differently than before based on new button value
void startMotorIncrement()
{
  TCCR2A = _BV(COM2A0)|_BV(COM2B1) |_BV(WGM21)|_BV(WGM20);
  TCCR2B = _BV(WGM22)|_BV(CS22)|_BV(CS21)|_BV(CS20);
  OCR2A = OCR2Avalue;  
//I want to be able to increment this value to change the duty cycle off pin 3
//this happens in another function and the motor is changed here
  OCR2B = OCR2Bvalue;  

}








